/* This file has been generated by the Perl script `afblue.pl', */
/* using data from file `afblue.dat'.                           */

/***************************************************************************/
/*                                                                         */
/*  afblue.h                                                               */
/*                                                                         */
/*    Auto-fitter data for blue strings (specification).                   */
/*                                                                         */
/*  Copyright 2013-2017 by                                                 */
/*  David Turner, Robert Wilhelm, and Werner Lemberg.                      */
/*                                                                         */
/*  This file is part of the FreeType project, and may only be used,       */
/*  modified, and distributed under the terms of the FreeType project      */
/*  license, LICENSE.TXT.  By continuing to use, modify, or distribute     */
/*  this file you indicate that you have read the license and              */
/*  understand and accept it fully.                                        */
/*                                                                         */
/***************************************************************************/


#ifndef AFBLUE_H_
#define AFBLUE_H_


FT_BEGIN_HEADER


  /* an auxiliary macro to decode a UTF-8 character -- since we only use */
  /* hard-coded, self-converted data, no error checking is performed     */
#define GET_UTF8_CHAR( ch, p )                      \
          do                                        \
          {                                         \
            ch = (unsigned char)*p++;               \
            if ( ch >= 0x80 )                       \
            {                                       \
              FT_UInt  len_;                        \
                                                    \
                                                    \
              if ( ch < 0xE0 )                      \
              {                                     \
                len_ = 1;                           \
                ch  &= 0x1F;                        \
              }                                     \
              else if ( ch < 0xF0 )                 \
              {                                     \
                len_ = 2;                           \
                ch  &= 0x0F;                        \
              }                                     \
              else                                  \
              {                                     \
                len_ = 3;                           \
                ch  &= 0x07;                        \
              }                                     \
                                                    \
              for ( ; len_ > 0; len_-- )            \
                ch = ( ch << 6 ) | ( *p++ & 0x3F ); \
            }                                       \
          } while ( 0 )


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                    B L U E   S T R I N G S                    *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* At the bottommost level, we define strings for finding blue zones. */


#define AF_BLUE_STRING_MAX_LEN  51

  /* The AF_Blue_String enumeration values are offsets into the */
  /* `af_blue_strings' array.                                   */

  typedef enum  AF_Blue_String_
  {
    AF_BLUE_STRING_ADLAM_CAPITAL_TOP = 0,
    AF_BLUE_STRING_ADLAM_CAPITAL_BOTTOM = 30,
    AF_BLUE_STRING_ADLAM_SMALL_TOP = 40,
    AF_BLUE_STRING_ADLAM_SMALL_BOTTOM = 65,
    AF_BLUE_STRING_ARABIC_TOP = 105,
    AF_BLUE_STRING_ARABIC_BOTTOM = 123,
    AF_BLUE_STRING_ARABIC_JOIN = 138,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_TOP = 141,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_BOTTOM = 165,
    AF_BLUE_STRING_ARMENIAN_SMALL_ASCENDER = 189,
    AF_BLUE_STRING_ARMENIAN_SMALL_TOP = 210,
    AF_BLUE_STRING_ARMENIAN_SMALL_BOTTOM = 234,
    AF_BLUE_STRING_ARMENIAN_SMALL_DESCENDER = 258,
    AF_BLUE_STRING_AVESTAN_TOP = 282,
    AF_BLUE_STRING_AVESTAN_BOTTOM = 302,
    AF_BLUE_STRING_BENGALI_BASE = 312,
    AF_BLUE_STRING_BENGALI_TOP = 344,
    AF_BLUE_STRING_BENGALI_HEAD = 372,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_TOP = 404,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_BOTTOM = 436,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SMALL_TOP = 468,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SMALL_BOTTOM = 500,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SUPS_TOP = 532,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SUPS_BOTTOM = 560,
    AF_BLUE_STRING_CARIAN_TOP = 592,
    AF_BLUE_STRING_CARIAN_BOTTOM = 632,
    AF_BLUE_STRING_CHEROKEE_CAPITAL = 667,
    AF_BLUE_STRING_CHEROKEE_SMALL_ASCENDER = 699,
    AF_BLUE_STRING_CHEROKEE_SMALL = 731,
    AF_BLUE_STRING_CHEROKEE_SMALL_DESCENDER = 763,
    AF_BLUE_STRING_CYPRIOT_TOP = 779,
    AF_BLUE_STRING_CYPRIOT_BOTTOM = 819,
    AF_BLUE_STRING_CYPRIOT_SMALL = 854,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_TOP = 869,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_BOTTOM = 893,
    AF_BLUE_STRING_CYRILLIC_SMALL = 917,
    AF_BLUE_STRING_CYRILLIC_SMALL_DESCENDER = 941,
    AF_BLUE_STRING_DESERET_CAPITAL_TOP = 950,
    AF_BLUE_STRING_DESERET_CAPITAL_BOTTOM = 975,
    AF_BLUE_STRING_DESERET_SMALL_TOP = 1000,
    AF_BLUE_STRING_DESERET_SMALL_BOTTOM = 1025,
    AF_BLUE_STRING_DEVANAGARI_BASE = 1050,
    AF_BLUE_STRING_DEVANAGARI_TOP = 1082,
    AF_BLUE_STRING_DEVANAGARI_HEAD = 1114,
    AF_BLUE_STRING_DEVANAGARI_BOTTOM = 1146,
    AF_BLUE_STRING_ETHIOPIC_TOP = 1154,
    AF_BLUE_STRING_ETHIOPIC_BOTTOM = 1186,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_TOP = 1218,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_BOTTOM = 1250,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_ASCENDER = 1282,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_DESCENDER = 1314,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_TOP = 1346,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_BOTTOM = 1378,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_TOP = 1410,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_BOTTOM = 1442,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_ASCENDER = 1474,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_DESCENDER = 1506,
    AF_BLUE_STRING_GLAGOLITIC_CAPITAL_TOP = 1538,
    AF_BLUE_STRING_GLAGOLITIC_CAPITAL_BOTTOM = 1570,
    AF_BLUE_STRING_GLAGOLITIC_SMALL_TOP = 1602,
    AF_BLUE_STRING_GLAGOLITIC_SMALL_BOTTOM = 1634,
    AF_BLUE_STRING_GOTHIC_TOP = 1666,
    AF_BLUE_STRING_GOTHIC_BOTTOM = 1706,
    AF_BLUE_STRING_GREEK_CAPITAL_TOP = 1726,
    AF_BLUE_STRING_GREEK_CAPITAL_BOTTOM = 1747,
    AF_BLUE_STRING_GREEK_SMALL_BETA_TOP = 1765,
    AF_BLUE_STRING_GREEK_SMALL = 1783,
    AF_BLUE_STRING_GREEK_SMALL_DESCENDER = 1807,
    AF_BLUE_STRING_GUJARATI_TOP = 1831,
    AF_BLUE_STRING_GUJARATI_BOTTOM = 1863,
    AF_BLUE_STRING_GUJARATI_ASCENDER = 1895,
    AF_BLUE_STRING_GUJARATI_DESCENDER = 1945,
    AF_BLUE_STRING_GUJARATI_DIGIT_TOP = 1978,
    AF_BLUE_STRING_GURMUKHI_BASE = 1998,
    AF_BLUE_STRING_GURMUKHI_HEAD = 2030,
    AF_BLUE_STRING_GURMUKHI_TOP = 2062,
    AF_BLUE_STRING_GURMUKHI_BOTTOM = 2094,
    AF_BLUE_STRING_GURMUKHI_DIGIT_TOP = 2126,
    AF_BLUE_STRING_HEBREW_TOP = 2146,
    AF_BLUE_STRING_HEBREW_BOTTOM = 2170,
    AF_BLUE_STRING_HEBREW_DESCENDER = 2188,
    AF_BLUE_STRING_KANNADA_TOP = 2203,
    AF_BLUE_STRING_KANNADA_BOTTOM = 2247,
    AF_BLUE_STRING_KHMER_TOP = 2279,
    AF_BLUE_STRING_KHMER_SUBSCRIPT_TOP = 2303,
    AF_BLUE_STRING_KHMER_BOTTOM = 2343,
    AF_BLUE_STRING_KHMER_DESCENDER = 2375,
    AF_BLUE_STRING_KHMER_LARGE_DESCENDER = 2409,
    AF_BLUE_STRING_KHMER_SYMBOLS_WAXING_TOP = 2496,
    AF_BLUE_STRING_KHMER_SYMBOLS_WANING_BOTTOM = 2504,
    AF_BLUE_STRING_LAO_TOP = 2512,
    AF_BLUE_STRING_LAO_BOTTOM = 2544,
    AF_BLUE_STRING_LAO_ASCENDER = 2576,
    AF_BLUE_STRING_LAO_LARGE_ASCENDER = 2592,
    AF_BLUE_STRING_LAO_DESCENDER = 2604,
    AF_BLUE_STRING_LATIN_CAPITAL_TOP = 2628,
    AF_BLUE_STRING_LATIN_CAPITAL_BOTTOM = 2644,
    AF_BLUE_STRING_LATIN_SMALL_F_TOP = 2660,
    AF_BLUE_STRING_LATIN_SMALL_TOP = 2674,
    AF_BLUE_STRING_LATIN_SMALL_BOTTOM = 2690,
    AF_BLUE_STRING_LATIN_SMALL_DESCENDER = 2706,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_TOP = 2716,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_BOTTOM = 2736,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_F_TOP = 2756,
    AF_BLUE_STRING_LATIN_SUBS_SMALL = 2776,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_DESCENDER = 2812,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_TOP = 2832,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_BOTTOM = 2863,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_F_TOP = 2892,
    AF_BLUE_STRING_LATIN_SUPS_SMALL = 2918,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_DESCENDER = 2943,
    AF_BLUE_STRING_LISU_TOP = 2954,
    AF_BLUE_STRING_LISU_BOTTOM = 2986,
    AF_BLUE_STRING_MALAYALAM_TOP = 3018,
    AF_BLUE_STRING_MALAYALAM_BOTTOM = 3062,
    AF_BLUE_STRING_MYANMAR_TOP = 3094,
    AF_BLUE_STRING_MYANMAR_BOTTOM = 3126,
    AF_BLUE_STRING_MYANMAR_ASCENDER = 3158,
    AF_BLUE_STRING_MYANMAR_DESCENDER = 3186,
    AF_BLUE_STRING_NKO_TOP = 3218,
    AF_BLUE_STRING_NKO_BOTTOM = 3242,
    AF_BLUE_STRING_NKO_SMALL_TOP = 3257,
    AF_BLUE_STRING_NKO_SMALL_BOTTOM = 3266,
    AF_BLUE_STRING_OL_CHIKI = 3278,
    AF_BLUE_STRING_OLD_TURKIC_TOP = 3302,
    AF_BLUE_STRING_OLD_TURKIC_BOTTOM = 3317,
    AF_BLUE_STRING_OSAGE_CAPITAL_TOP = 3337,
    AF_BLUE_STRING_OSAGE_CAPITAL_BOTTOM = 3377,
    AF_BLUE_STRING_OSAGE_CAPITAL_DESCENDER = 3407,
    AF_BLUE_STRING_OSAGE_SMALL_TOP = 3422,
    AF_BLUE_STRING_OSAGE_SMALL_BOTTOM = 3462,
    AF_BLUE_STRING_OSAGE_SMALL_ASCENDER = 3502,
    AF_BLUE_STRING_OSAGE_SMALL_DESCENDER = 3527,
    AF_BLUE_STRING_SINHALA_TOP = 3542,
    AF_BLUE_STRING_SINHALA_BOTTOM = 3574,
    AF_BLUE_STRING_SINHALA_DESCENDER = 3606,
    AF_BLUE_STRING_SUNDANESE_TOP = 3650,
    AF_BLUE_STRING_SUNDANESE_BOTTOM = 3674,
    AF_BLUE_STRING_SUNDANESE_DESCENDER = 3706,
    AF_BLUE_STRING_TAI_VIET_TOP = 3714,
    AF_BLUE_STRING_TAI_VIET_BOTTOM = 3734,
    AF_BLUE_STRING_TAMIL_TOP = 3746,
    AF_BLUE_STRING_TAMIL_BOTTOM = 3778,
    AF_BLUE_STRING_TELUGU_TOP = 3810,
    AF_BLUE_STRING_TELUGU_BOTTOM = 3838,
    AF_BLUE_STRING_THAI_TOP = 3866,
    AF_BLUE_STRING_THAI_BOTTOM = 3890,
    AF_BLUE_STRING_THAI_ASCENDER = 3918,
    AF_BLUE_STRING_THAI_LARGE_ASCENDER = 3930,
    AF_BLUE_STRING_THAI_DESCENDER = 3942,
    AF_BLUE_STRING_THAI_LARGE_DESCENDER = 3958,
    AF_BLUE_STRING_THAI_DIGIT_TOP = 3966,
    AF_BLUE_STRING_TIFINAGH = 3978,
    af_blue_1_1 = 4009,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRING_CJK_TOP = af_blue_1_1 + 1,
    AF_BLUE_STRING_CJK_BOTTOM = af_blue_1_1 + 203,
    af_blue_1_1_1 = af_blue_1_1 + 404,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    AF_BLUE_STRING_CJK_LEFT = af_blue_1_1_1 + 1,
    AF_BLUE_STRING_CJK_RIGHT = af_blue_1_1_1 + 204,
    af_blue_1_1_2 = af_blue_1_1_1 + 405,
#else
    af_blue_1_1_2 = af_blue_1_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_1_2 = af_blue_1_1_2 + 0,
#else
    af_blue_1_2 = af_blue_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRING_MAX   /* do not remove */

  } AF_Blue_String;


  FT_LOCAL_ARRAY( char )
  af_blue_strings[];


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                 B L U E   S T R I N G S E T S                 *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* The next level is to group blue strings into style-specific sets. */


  /* Properties are specific to a writing system.  We assume that a given  */
  /* blue string can't be used in more than a single writing system, which */
  /* is a safe bet.                                                        */
#define AF_BLUE_PROPERTY_LATIN_TOP       ( 1U << 0 )  /* must have value 1 */
#define AF_BLUE_PROPERTY_LATIN_SUB_TOP   ( 1U << 1 )
#define AF_BLUE_PROPERTY_LATIN_NEUTRAL   ( 1U << 2 )
#define AF_BLUE_PROPERTY_LATIN_X_HEIGHT  ( 1U << 3 )
#define AF_BLUE_PROPERTY_LATIN_LONG      ( 1U << 4 )

#define AF_BLUE_PROPERTY_CJK_TOP    ( 1U << 0 )       /* must have value 1 */
#define AF_BLUE_PROPERTY_CJK_HORIZ  ( 1U << 1 )       /* must have value 2 */
#define AF_BLUE_PROPERTY_CJK_RIGHT  AF_BLUE_PROPERTY_CJK_TOP


#define AF_BLUE_STRINGSET_MAX_LEN  8

  /* The AF_Blue_Stringset enumeration values are offsets into the */
  /* `af_blue_stringsets' array.                                   */

  typedef enum  AF_Blue_Stringset_
  {
    AF_BLUE_STRINGSET_ADLM = 0,
    AF_BLUE_STRINGSET_ARAB = 5,
    AF_BLUE_STRINGSET_ARMN = 9,
    AF_BLUE_STRINGSET_AVST = 16,
    AF_BLUE_STRINGSET_BENG = 19,
    AF_BLUE_STRINGSET_CANADIAN_SYLLABICS = 24,
    AF_BLUE_STRINGSET_CARI = 31,
    AF_BLUE_STRINGSET_CHER = 34,
    AF_BLUE_STRINGSET_CPRT = 41,
    AF_BLUE_STRINGSET_CYRL = 46,
    AF_BLUE_STRINGSET_DEVA = 52,
    AF_BLUE_STRINGSET_DSRT = 58,
    AF_BLUE_STRINGSET_ETHI = 63,
    AF_BLUE_STRINGSET_GEOR = 66,
    AF_BLUE_STRINGSET_GEOK = 71,
    AF_BLUE_STRINGSET_GLAG = 78,
    AF_BLUE_STRINGSET_GOTH = 83,
    AF_BLUE_STRINGSET_GREK = 86,
    AF_BLUE_STRINGSET_GUJR = 93,
    AF_BLUE_STRINGSET_GURU = 99,
    AF_BLUE_STRINGSET_HEBR = 105,
    AF_BLUE_STRINGSET_KNDA = 109,
    AF_BLUE_STRINGSET_KHMR = 112,
    AF_BLUE_STRINGSET_KHMS = 118,
    AF_BLUE_STRINGSET_LAO = 121,
    AF_BLUE_STRINGSET_LATN = 127,
    AF_BLUE_STRINGSET_LATB = 134,
    AF_BLUE_STRINGSET_LATP = 141,
    AF_BLUE_STRINGSET_LISU = 148,
    AF_BLUE_STRINGSET_MLYM = 151,
    AF_BLUE_STRINGSET_MYMR = 154,
    AF_BLUE_STRINGSET_NKOO = 159,
    AF_BLUE_STRINGSET_NONE = 164,
    AF_BLUE_STRINGSET_OLCK = 165,
    AF_BLUE_STRINGSET_ORKH = 168,
    AF_BLUE_STRINGSET_OSGE = 171,
    AF_BLUE_STRINGSET_SINH = 179,
    AF_BLUE_STRINGSET_SUND = 183,
    AF_BLUE_STRINGSET_TAML = 187,
    AF_BLUE_STRINGSET_TAVT = 190,
    AF_BLUE_STRINGSET_TELU = 193,
    AF_BLUE_STRINGSET_THAI = 196,
    AF_BLUE_STRINGSET_TFNG = 204,
    af_blue_2_1 = 207,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRINGSET_HANI = af_blue_2_1 + 0,
    af_blue_2_1_1 = af_blue_2_1 + 2,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    af_blue_2_1_2 = af_blue_2_1_1 + 2,
#else
    af_blue_2_1_2 = af_blue_2_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_2_2 = af_blue_2_1_2 + 1,
#else
    af_blue_2_2 = af_blue_2_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRINGSET_MAX   /* do not remove */

  } AF_Blue_Stringset;


  typedef struct  AF_Blue_StringRec_
  {
    AF_Blue_String  string;
    FT_UShort       properties;

  } AF_Blue_StringRec;


  FT_LOCAL_ARRAY( AF_Blue_StringRec )
  af_blue_stringsets[];

/* */

FT_END_HEADER


#endif /* AFBLUE_H_ */


/* END */
